import { __assign } from "tslib";
import * as React from "react";
import { useContext, useMemo } from "react";
import { MotionContext } from "../motion/context/MotionContext";
/**
 * Define accessibility options for a tree. Can be used to force the tree into Reduced Motion mode,
 * or disable device detection.
 *
 * @internal
 */
export function ReducedMotion(_a) {
    var children = _a.children, enabled = _a.enabled;
    var context = useContext(MotionContext);
    context = useMemo(function () { return (__assign(__assign({}, context), { isReducedMotion: enabled })); }, [enabled]);
    return (React.createElement(MotionContext.Provider, { value: context }, children));
}
//# sourceMappingURL=ReducedMotion.js.map